#include "FiletypeXYZ.h"

std::unique_ptr<ReadResult> FiletypeXYZ::readFile(const std::string &filename)
{
    throw std::runtime_error("no XYZ reading!");
}

void FiletypeXYZ::plotParticle(const Particle &p)
{
    m_particles.push_back(p);
}

void FiletypeXYZ::writeFile(const std::string &filename, int iteration)
{
    std::ofstream file;
    std::stringstream strstr;
    strstr << filename << "_" << std::setfill('0') << std::setw(4) << iteration << ".xyz";

    file.open(strstr.str().c_str());
    file << m_particles.size() << std::endl;
    file << "Generated by MolSim. See http://openbabel.org/wiki/XYZ_(format) for "
            "file format doku." << std::endl;

    auto iterator = m_particles.begin();
    while(iterator != m_particles.end()) {
        Particle &p = *iterator;
        glm::dvec3 x = p.getPos();
        file << "Ar ";
        file.setf(std::ios_base::showpoint);

        for(int i = 0; i < 3; i++) {
            file << x[i] << " ";
        }

        file << std::endl;
        iterator++;
    }

    file.close();
}

// Assignment 4.3
void FiletypeXYZ::initExportFile(const std::string &filename) {}
void FiletypeXYZ::appendLineToFile(std::string line) {}
